# What is Shortcode Snippets?

*Do you want to use the same snippet of text or HTML throughout your site but only have to change the value in one location? If so, this plugin maybe just what you need!*

Create your own Shortcodes and assign content to them. Using the standard WP editor, you can add text, HTML, JavaScript, images or other elements that your WordPress install and plugins allow. The main advantage is ability to create a shortcode once and re-use it throughout your site.

```
[sv slug="your-slug-name"]
```

The plugin is available in a [Free](https://wordpress.org/plugins/shortcode-variables/) and [Premium](https://shop.yeken.uk/product/shortcode-variables/) versions. This documentation will help you to set up Meal Tracker to suit your business.  
  
## Features  
  
* Create a shortcode once and place in multiple locations throughout your website.
* Update the shortcode and watch it change throughout the website.
* Parameters to extend your shortcodes.
* Free and Premium helper shortcodes to make life easier.
* Multi-site support.
* Process shortcodes within WordPress menu titles.

## Getting Started  
  
1. Ensure your hosting matches the minimum requirements specified by [WordPress Requirements](https://wordpress.org/about/requirements/). Unfortunately, Shortcode Snippets may not work on older versions.  
2. Install the [Shortcode Snippets plugin](https://wordpress.org/plugins/shortcode-variables/).  
3. Within your WordPress Admin area, navigate to “Plugins” > “Add New”. Search for “Shortcode Snippets” and click “Install Now”.  
4. Activate the plugin.  
5. [Upgrade the plugin]({{ site.baseurl}}/upgrade.html) if you require additional [features]({{ site.baseurl}}/features.html). We offer a free trial of the Premium versions of the plugin, [get your free trial now](https://shop.yeken.uk/get-a-trial-license/).
6. Configure the plugin. Navigate to “Shortcode Snippets” > “Your Shortcodes” and review / modify each setting to meet your needs.  
7. To get started, create your own shortcode. Within the WP Dashboard, navigate to "Snippet Shortcodes" > "Your Snippet Shortcodes". From here click "Add a new Shortcode snippet" and follow the steps.

## Free Trial 

If you would like to trial the [Premium](https://shop.yeken.uk/product/shortcode-variables/) version of the plugin, then we are happy to provide a free trial. [Get your free trial now](https://shop.yeken.uk/get-a-trial-license/). 

## Translate Shortcode Snippets  
All [YeKen](https://www.yeken.uk) plugins are fully translatable and can be translated with [Loco Translate](https://en-gb.wordpress.org/plugins/loco-translate/). For further information, please read our [guide on translating YeKen plugins]({{ site.baseurl}}/translate.html).
